/*
 * Properties.java
 *
 * Created on 2011/08/20, 16:33:03
 */
package yukihane.inqubus.gui;

import static javax.swing.GroupLayout.DEFAULT_SIZE;
import static javax.swing.GroupLayout.PREFERRED_SIZE;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.BorderFactory;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.WindowConstants;
import org.apache.commons.configuration.ConfigurationException;
import yukihane.inqubus.Config;

/**
 *
 * @author yuki
 */
public class ConfigDialog extends JDialog {
    private static final long serialVersionUID = 1L;
    private static final Logger logger = Logger.getLogger(ConfigDialog.class.getName());

    /** Creates new form Properties */
    public ConfigDialog() {
        this(null);
    }

    public ConfigDialog(JFrame owner){
        super(owner);

        final JTabbedPane tabbedPane = new JTabbedPane();
        final JPanel pnlNetwork = new JPanel();
        final JPanel pnlAccount = new JPanel();
        final JLabel lblMail = new JLabel();
        fldMail = new JTextField();
        final JLabel lblPassword = new JLabel();
        fldPassword = new JTextField();
        final JPanel pnlProxy = new JPanel();
        cbProxyUse = new JCheckBox();
        final JLabel lblProxyHost = new JLabel();
        final JLabel lblProxyPort = new JLabel();
        fldProxyHost = new JTextField();
        fldProxyPort = new JTextField();
        final JPanel pnlFile = new JPanel();
        final JPanel pnlFileVideo = new JPanel();
        final JLabel lblVideoDir = new JLabel();
        final JLabel lblVideoFileNamepattern = new JLabel();
        fldVideoDir = new JTextField();
        fldVideoFileNamePattern = new JTextField();
        btnVideoDir = new JButton();
        cbVideoLocal = new JCheckBox();
        final JPanel pnlFileComment = new JPanel();
        final JLabel lblCommentDir = new JLabel();
        final JLabel lblCommentFileNamePattern = new JLabel();
        fldCommentDir = new JTextField();
        fldCommentFileNamePattern = new JTextField();
        btnCommentDir = new JButton();
        cbCommentLocal = new JCheckBox();
        final JPanel pnlFileOutput = new JPanel();
        final JLabel lblOutputDir = new JLabel();
        final JLabel lblOutputFileNamePattern = new JLabel();
        fldOutputDir = new JTextField();
        fldOutputFileNamePattern = new JTextField();
        btnOutputDir = new JButton();
        cbOutputEnable = new JCheckBox();
        cbOutputCommentOverlay = new JCheckBox();
        cbOutputDisplayProgress = new JCheckBox();
        final JPanel pnlComment = new JPanel();
        final JPanel pnlCommentStandard = new JPanel();
        final JLabel lblCommentSize = new JLabel();
        cbCommentSizeAuto = new JCheckBox();
        final JLabel lblCommentSizeManual = new JLabel();
        fldCommentSizeManual = new JTextField();
        final JLabel lblCommentMinSize = new JLabel();
        cbCommentMinSizeAuto = new JCheckBox();
        fldCommentMinSizeManual = new JTextField();
        final JLabel lblCommentMinSizeManual = new JLabel();
        final JLabel lblCommentDisplayMax = new JLabel();
        cbCommentDisplaySizeDefault = new JCheckBox();
        final JLabel lblCommentDisplayMaxManual = new JLabel();
        fldCommentDisplaySizeManual = new JTextField();
        final JPanel pnlCommentAdvanced = new JPanel();
        final JLabel lblFontPath = new JLabel();
        cbFontSizeArrangeDisable = new JCheckBox();
        cbCommentOpaque = new JCheckBox();
        fldFontPath = new JTextField();
        btnFontPath = new JButton();
        final JLabel lblFontIndex = new JLabel();
        final JLabel lblFontShadow = new JLabel();
        fldFontIndex = new JTextField();
        final JPanel pnlFfmpeg = new JPanel();
        final JPanel jPanel10 = new JPanel();
        final JLabel lblFfmpegPath = new JLabel();
        final JLabel lblFfmpegDllPath = new JLabel();
        fldFfmpegPath = new JTextField();
        fldFfmpegDllPath = new JTextField();
        btnFfmpegPath = new JButton();
        btnFfmpegDllPath = new JButton();
        final JPanel pnlNgSetting = new JPanel();
        final JPanel pnlSearch = new JPanel();
        final JPanel pnlSearchCache = new JPanel();
        final JLabel lblSearchCache = new JLabel();
        fldSearchCache = new JTextField();

        setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

        pnlNetwork.setBorder(BorderFactory.createEmptyBorder(1, 1, 1, 1));

        pnlAccount.setBorder(BorderFactory.createTitledBorder("アカウント"));

        lblMail.setText("ID(メールアドレス)");

        lblPassword.setText("パスワード");

        GroupLayout gl_pnlAccount = new GroupLayout(pnlAccount);
        pnlAccount.setLayout(gl_pnlAccount);
        gl_pnlAccount.setHorizontalGroup(
            gl_pnlAccount.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlAccount.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlAccount.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(lblMail)
                    .addComponent(lblPassword))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlAccount.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(fldPassword, GroupLayout.DEFAULT_SIZE, 306, Short.MAX_VALUE)
                    .addComponent(fldMail, GroupLayout.DEFAULT_SIZE, 306, Short.MAX_VALUE))
                .addContainerGap())
        );
        gl_pnlAccount.setVerticalGroup(
            gl_pnlAccount.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlAccount.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlAccount.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblMail)
                    .addComponent(fldMail, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlAccount.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblPassword)
                    .addComponent(fldPassword, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pnlProxy.setBorder(BorderFactory.createTitledBorder("プロキシ"));

        cbProxyUse.setText("プロキシを使用する");

        lblProxyHost.setText("ホスト名");

        lblProxyPort.setText("ポート番号");

        GroupLayout gl_pnlProxy = new GroupLayout(pnlProxy);
        pnlProxy.setLayout(gl_pnlProxy);
        gl_pnlProxy.setHorizontalGroup(
            gl_pnlProxy.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlProxy.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlProxy.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(cbProxyUse)
                    .addGroup(gl_pnlProxy.createSequentialGroup()
                        .addComponent(lblProxyHost)
                        .addGap(18, 18, 18)
                        .addComponent(fldProxyHost, GroupLayout.PREFERRED_SIZE, 168, GroupLayout.PREFERRED_SIZE))
                    .addGroup(gl_pnlProxy.createSequentialGroup()
                        .addComponent(lblProxyPort)
                        .addPreferredGap(ComponentPlacement.RELATED)
                        .addComponent(fldProxyPort, GroupLayout.PREFERRED_SIZE, 76, GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(181, Short.MAX_VALUE))
        );
        gl_pnlProxy.setVerticalGroup(
            gl_pnlProxy.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlProxy.createSequentialGroup()
                .addContainerGap()
                .addComponent(cbProxyUse)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlProxy.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblProxyHost)
                    .addComponent(fldProxyHost, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlProxy.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblProxyPort)
                    .addComponent(fldProxyPort, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addContainerGap(39, Short.MAX_VALUE))
        );

        GroupLayout gl_pnlNetwork = new GroupLayout(pnlNetwork);
        pnlNetwork.setLayout(gl_pnlNetwork);
        gl_pnlNetwork.setHorizontalGroup(
            gl_pnlNetwork.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(GroupLayout.Alignment.TRAILING, gl_pnlNetwork.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlNetwork.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(pnlProxy, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnlAccount, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        gl_pnlNetwork.setVerticalGroup(
            gl_pnlNetwork.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlNetwork.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlAccount, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(pnlProxy, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addContainerGap(178, Short.MAX_VALUE))
        );

        tabbedPane.addTab("ネットワーク", pnlNetwork);

        pnlFileVideo.setBorder(BorderFactory.createTitledBorder("動画"));

        lblVideoDir.setText("保存フォルダ");

        lblVideoFileNamepattern.setText("ファイル名規則");

        btnVideoDir.setText("...");

        cbVideoLocal.setText("local");

        GroupLayout gl_pnlFileVideo = new GroupLayout(pnlFileVideo);
        pnlFileVideo.setLayout(gl_pnlFileVideo);
        gl_pnlFileVideo.setHorizontalGroup(
            gl_pnlFileVideo.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(GroupLayout.Alignment.TRAILING, gl_pnlFileVideo.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlFileVideo.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(lblVideoFileNamepattern)
                    .addComponent(lblVideoDir))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlFileVideo.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(gl_pnlFileVideo.createSequentialGroup()
                        .addComponent(fldVideoDir, GroupLayout.DEFAULT_SIZE, 262, Short.MAX_VALUE)
                        .addPreferredGap(ComponentPlacement.RELATED)
                        .addComponent(btnVideoDir))
                    .addGroup(GroupLayout.Alignment.TRAILING, gl_pnlFileVideo.createSequentialGroup()
                        .addComponent(fldVideoFileNamePattern, GroupLayout.PREFERRED_SIZE, 165, GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(ComponentPlacement.RELATED, 94, Short.MAX_VALUE)
                        .addComponent(cbVideoLocal)))
                .addContainerGap())
        );
        gl_pnlFileVideo.setVerticalGroup(
            gl_pnlFileVideo.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlFileVideo.createSequentialGroup()
                .addGroup(gl_pnlFileVideo.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblVideoDir)
                    .addComponent(fldVideoDir, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnVideoDir))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlFileVideo.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblVideoFileNamepattern)
                    .addComponent(fldVideoFileNamePattern, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(cbVideoLocal))
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pnlFileComment.setBorder(BorderFactory.createTitledBorder("コメント"));

        lblCommentDir.setText("保存フォルダ");

        lblCommentFileNamePattern.setText("ファイル名規則");

        btnCommentDir.setText("...");

        cbCommentLocal.setText("local");

        GroupLayout gl_pnlFileComment = new GroupLayout(pnlFileComment);
        pnlFileComment.setLayout(gl_pnlFileComment);
        gl_pnlFileComment.setHorizontalGroup(
            gl_pnlFileComment.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlFileComment.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlFileComment.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(lblCommentFileNamePattern)
                    .addComponent(lblCommentDir))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlFileComment.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(gl_pnlFileComment.createSequentialGroup()
                        .addComponent(fldCommentFileNamePattern, GroupLayout.PREFERRED_SIZE, 166, GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(ComponentPlacement.RELATED, 93, Short.MAX_VALUE)
                        .addComponent(cbCommentLocal))
                    .addGroup(gl_pnlFileComment.createSequentialGroup()
                        .addComponent(fldCommentDir, GroupLayout.DEFAULT_SIZE, 262, Short.MAX_VALUE)
                        .addPreferredGap(ComponentPlacement.RELATED)
                        .addComponent(btnCommentDir)))
                .addContainerGap())
        );
        gl_pnlFileComment.setVerticalGroup(
            gl_pnlFileComment.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlFileComment.createSequentialGroup()
                .addGroup(gl_pnlFileComment.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblCommentDir)
                    .addComponent(fldCommentDir, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnCommentDir))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlFileComment.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblCommentFileNamePattern)
                    .addComponent(fldCommentFileNamePattern, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(cbCommentLocal))
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pnlFileOutput.setBorder(BorderFactory.createTitledBorder("変換動画"));

        lblOutputDir.setText("保存フォルダ");

        lblOutputFileNamePattern.setText("ファイル名規則");

        btnOutputDir.setText("...");

        cbOutputEnable.setText("変換");

        cbOutputCommentOverlay.setText("コメント付与");

        cbOutputDisplayProgress.setText("変換中動画表示");

        GroupLayout gl_pnlFileOutput = new GroupLayout(pnlFileOutput);
        pnlFileOutput.setLayout(gl_pnlFileOutput);
        gl_pnlFileOutput.setHorizontalGroup(
            gl_pnlFileOutput.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlFileOutput.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlFileOutput.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(lblOutputFileNamePattern)
                    .addComponent(lblOutputDir))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlFileOutput.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(gl_pnlFileOutput.createSequentialGroup()
                        .addComponent(fldOutputDir, GroupLayout.DEFAULT_SIZE, 262, Short.MAX_VALUE)
                        .addPreferredGap(ComponentPlacement.RELATED)
                        .addComponent(btnOutputDir)
                        .addContainerGap())
                    .addGroup(GroupLayout.Alignment.TRAILING, gl_pnlFileOutput.createSequentialGroup()
                        .addComponent(fldOutputFileNamePattern, GroupLayout.PREFERRED_SIZE, 167, GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(ComponentPlacement.RELATED, 23, Short.MAX_VALUE)
                        .addGroup(gl_pnlFileOutput.createParallelGroup(GroupLayout.Alignment.LEADING)
                            .addComponent(cbOutputDisplayProgress)
                            .addGroup(gl_pnlFileOutput.createSequentialGroup()
                                .addComponent(cbOutputEnable)
                                .addPreferredGap(ComponentPlacement.RELATED)
                                .addComponent(cbOutputCommentOverlay))))))
        );
        gl_pnlFileOutput.setVerticalGroup(
            gl_pnlFileOutput.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlFileOutput.createSequentialGroup()
                .addGroup(gl_pnlFileOutput.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblOutputDir)
                    .addComponent(fldOutputDir, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnOutputDir))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlFileOutput.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblOutputFileNamePattern)
                    .addComponent(fldOutputFileNamePattern, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(cbOutputCommentOverlay)
                    .addComponent(cbOutputEnable))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(cbOutputDisplayProgress)
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        final JPanel pnlFileProhibit = new JPanel();
        pnlFileProhibit.setBorder(BorderFactory.createTitledBorder("禁則文字"));
        final JLabel lblReplaceFrom = new JLabel("置換対象文字");
        final JLabel lblReplaceTo = new JLabel("置換後文字");

        final GroupLayout glProhibit = new GroupLayout(pnlFileProhibit);
        glProhibit.setAutoCreateContainerGaps(true);
        glProhibit.setAutoCreateGaps(true);
        pnlFileProhibit.setLayout(glProhibit);

        glProhibit.setHorizontalGroup(glProhibit.createSequentialGroup()
            .addGroup(glProhibit.createParallelGroup()
                .addComponent(lblReplaceFrom)
                .addComponent(lblReplaceTo)
            )
            .addGroup(glProhibit.createParallelGroup()
                .addComponent(fldReplaceFrom)
                .addComponent(fldReplaceTo)
            )
        );

        glProhibit.setVerticalGroup(glProhibit.createSequentialGroup()
            .addGroup(glProhibit.createParallelGroup(Alignment.BASELINE)
                .addComponent(lblReplaceFrom)
                .addComponent(fldReplaceFrom)
            )
            .addGroup(glProhibit.createParallelGroup(Alignment.BASELINE)
                .addComponent(lblReplaceTo)
                .addComponent(fldReplaceTo)
            )
        );

        GroupLayout gl_pnlFile = new GroupLayout(pnlFile);
        pnlFile.setLayout(gl_pnlFile);
        gl_pnlFile.setHorizontalGroup(
            gl_pnlFile.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(GroupLayout.Alignment.TRAILING, gl_pnlFile.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlFile.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(pnlFileOutput, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnlFileVideo, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnlFileComment, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnlFileProhibit, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                )
                .addContainerGap())
        );
        gl_pnlFile.setVerticalGroup(
            gl_pnlFile.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlFile.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlFileVideo, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(pnlFileComment, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(pnlFileOutput, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(pnlFileProhibit, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        tabbedPane.addTab("ファイル", pnlFile);

        pnlCommentStandard.setBorder(BorderFactory.createTitledBorder(""));

        lblCommentSize.setText("再生時間に応じたコメントの取得数");

        cbCommentSizeAuto.setText("自動調整");

        lblCommentSizeManual.setText("手動取得");

        lblCommentMinSize.setText("1分当たりのコメント取得数");

        cbCommentMinSizeAuto.setText("自動調整");

        lblCommentMinSizeManual.setText("手動取得");

        lblCommentDisplayMax.setText("1画面に表示する最大コメント数");

        cbCommentDisplaySizeDefault.setText("標準(30)");

        lblCommentDisplayMaxManual.setText("手動設定");

        GroupLayout gl_pnlCommentStandard = new GroupLayout(pnlCommentStandard);
        pnlCommentStandard.setLayout(gl_pnlCommentStandard);
        gl_pnlCommentStandard.setAutoCreateContainerGaps(true);
        gl_pnlCommentStandard.setAutoCreateGaps(true);
        gl_pnlCommentStandard.setHorizontalGroup(
            gl_pnlCommentStandard.createSequentialGroup()
                .addGroup(gl_pnlCommentStandard.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(lblCommentSize)
                    .addComponent(lblCommentMinSize)
                    .addComponent(lblCommentDisplayMax))
                .addGroup(gl_pnlCommentStandard.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(cbCommentSizeAuto)
                    .addComponent(cbCommentMinSizeAuto)
                    .addComponent(cbCommentDisplaySizeDefault))
                .addGroup(gl_pnlCommentStandard.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(lblCommentSizeManual)
                    .addComponent(lblCommentMinSizeManual)
                    .addComponent(lblCommentDisplayMaxManual))
                .addGroup(gl_pnlCommentStandard.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(fldCommentSizeManual, 48, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(fldCommentMinSizeManual, 48, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(fldCommentDisplaySizeManual, 48, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
        );
        gl_pnlCommentStandard.setVerticalGroup(
            gl_pnlCommentStandard.createSequentialGroup()
                .addGroup(gl_pnlCommentStandard.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblCommentSize)
                    .addComponent(cbCommentSizeAuto)
                    .addComponent(lblCommentSizeManual)
                    .addComponent(fldCommentSizeManual))
                .addGroup(gl_pnlCommentStandard.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblCommentMinSize)
                    .addComponent(cbCommentMinSizeAuto)
                    .addComponent(lblCommentMinSizeManual)
                    .addComponent(fldCommentMinSizeManual))
                .addGroup(gl_pnlCommentStandard.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblCommentDisplayMax)
                    .addComponent(cbCommentDisplaySizeDefault)
                    .addComponent(lblCommentDisplayMaxManual)
                    .addComponent(fldCommentDisplaySizeManual))
        );

        pnlCommentAdvanced.setBorder(BorderFactory.createTitledBorder("高度な設定"));

        lblFontPath.setText("フォントパス");

        cbFontSizeArrangeDisable.setText("フォントサイズ調整を行わない");

        cbCommentOpaque.setText("コメント透明化を行わない");

        btnFontPath.setText("...");

        lblFontIndex.setText("フォント番号");

        lblFontShadow.setText("影の種類");
        final ComboBoxModel<String> cbmFontShadow
                = new DefaultComboBoxModel<>(new String[]{"0:なし", "1:ニコニコ動画風", "2:右下", "3:囲い込み"});
        cmbFontShadow.setModel(cbmFontShadow);

        GroupLayout gl_pnlCommentAdvanced = new GroupLayout(pnlCommentAdvanced);
        pnlCommentAdvanced.setLayout(gl_pnlCommentAdvanced);
        gl_pnlCommentAdvanced.setHorizontalGroup(
            gl_pnlCommentAdvanced.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlCommentAdvanced.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlCommentAdvanced.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(cbCommentOpaque)
                    .addGroup(gl_pnlCommentAdvanced.createSequentialGroup()
                        .addGroup(gl_pnlCommentAdvanced.createParallelGroup(GroupLayout.Alignment.LEADING)
                            .addComponent(lblFontPath)
                            .addComponent(lblFontIndex)
                            .addComponent(lblFontShadow))
                        .addGap(18, 18, 18)
                        .addGroup(gl_pnlCommentAdvanced.createParallelGroup(GroupLayout.Alignment.LEADING)
                            .addComponent(fldFontPath, GroupLayout.DEFAULT_SIZE, 275, Short.MAX_VALUE)
                            .addGroup(gl_pnlCommentAdvanced.createParallelGroup(GroupLayout.Alignment.TRAILING, false)
                                .addComponent(cmbFontShadow, GroupLayout.Alignment.LEADING)
                                .addComponent(fldFontIndex, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 48, Short.MAX_VALUE)))
                        .addPreferredGap(ComponentPlacement.RELATED)
                        .addComponent(btnFontPath))
                    .addComponent(cbFontSizeArrangeDisable))
                .addContainerGap())
        );
        gl_pnlCommentAdvanced.setVerticalGroup(
            gl_pnlCommentAdvanced.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlCommentAdvanced.createSequentialGroup()
                .addGroup(gl_pnlCommentAdvanced.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblFontPath)
                    .addComponent(fldFontPath, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnFontPath))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlCommentAdvanced.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblFontIndex)
                    .addComponent(fldFontIndex, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_pnlCommentAdvanced.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblFontShadow)
                    .addComponent(cmbFontShadow, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(cbFontSizeArrangeDisable)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(cbCommentOpaque)
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        GroupLayout gl_pnlComment = new GroupLayout(pnlComment);
        pnlComment.setLayout(gl_pnlComment);
        gl_pnlComment.setHorizontalGroup(
            gl_pnlComment.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(GroupLayout.Alignment.TRAILING, gl_pnlComment.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlComment.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(pnlCommentAdvanced, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnlCommentStandard, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        gl_pnlComment.setVerticalGroup(
            gl_pnlComment.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlComment.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlCommentStandard, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(pnlCommentAdvanced, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addContainerGap(168, Short.MAX_VALUE))
        );

        tabbedPane.addTab("コメント", pnlComment);

        jPanel10.setBorder(BorderFactory.createTitledBorder("ファイルパス"));

        lblFfmpegPath.setText("ffmpeg");

        lblFfmpegDllPath.setText("拡張ライブラリ");

        btnFfmpegPath.setText("...");

        btnFfmpegDllPath.setText("...");

        GroupLayout gl_jPanel10 = new GroupLayout(jPanel10);
        jPanel10.setLayout(gl_jPanel10);
        gl_jPanel10.setHorizontalGroup(
            gl_jPanel10.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_jPanel10.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_jPanel10.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(lblFfmpegDllPath)
                    .addComponent(lblFfmpegPath))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_jPanel10.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(fldFfmpegDllPath, GroupLayout.Alignment.TRAILING, GroupLayout.DEFAULT_SIZE, 280, Short.MAX_VALUE)
                    .addComponent(fldFfmpegPath, GroupLayout.Alignment.TRAILING, GroupLayout.DEFAULT_SIZE, 280, Short.MAX_VALUE))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_jPanel10.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(btnFfmpegPath, GroupLayout.Alignment.TRAILING)
                    .addComponent(btnFfmpegDllPath, GroupLayout.Alignment.TRAILING))
                .addContainerGap())
        );
        gl_jPanel10.setVerticalGroup(
            gl_jPanel10.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_jPanel10.createSequentialGroup()
                .addGroup(gl_jPanel10.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblFfmpegPath)
                    .addComponent(fldFfmpegPath, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnFfmpegPath))
                .addPreferredGap(ComponentPlacement.RELATED)
                .addGroup(gl_jPanel10.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblFfmpegDllPath)
                    .addComponent(fldFfmpegDllPath, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnFfmpegDllPath))
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pnlFfmpegParam.setBorder(BorderFactory.createTitledBorder("ffmpegパラメータ"));



        GroupLayout gl_pnlFfmpeg = new GroupLayout(pnlFfmpeg);
        pnlFfmpeg.setLayout(gl_pnlFfmpeg);
        gl_pnlFfmpeg.setHorizontalGroup(
            gl_pnlFfmpeg.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(GroupLayout.Alignment.TRAILING, gl_pnlFfmpeg.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlFfmpeg.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(pnlFfmpegParam, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel10, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        gl_pnlFfmpeg.setVerticalGroup(
            gl_pnlFfmpeg.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlFfmpeg.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel10, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(pnlFfmpegParam, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabbedPane.addTab("ffmpeg", pnlFfmpeg);

        pnlNgWord.setBorder(BorderFactory.createTitledBorder("NGワード"));
        pnlNgId.setBorder(BorderFactory.createTitledBorder("NGID"));

        GroupLayout gl_pnlNgSetting = new GroupLayout(pnlNgSetting);
        pnlNgSetting.setLayout(gl_pnlNgSetting);
        gl_pnlNgSetting.setHorizontalGroup(
            gl_pnlNgSetting.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(GroupLayout.Alignment.TRAILING, gl_pnlNgSetting.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlNgSetting.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(pnlNgId, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnlNgWord, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        gl_pnlNgSetting.setVerticalGroup(
            gl_pnlNgSetting.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlNgSetting.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlNgWord, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(pnlNgId, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabbedPane.addTab("NG設定", pnlNgSetting);

        pnlSearchVideo.setBorder(BorderFactory.createTitledBorder("動画検索対象フォルダ"));
        pnlSearchComment.setBorder(BorderFactory.createTitledBorder("コメント検索対象フォルダ"));

        pnlSearchCache.setBorder(BorderFactory.createEtchedBorder());

        lblSearchCache.setText("キャッシュ更新(秒)");

        GroupLayout gl_pnlSearchCache = new GroupLayout(pnlSearchCache);
        pnlSearchCache.setLayout(gl_pnlSearchCache);
        gl_pnlSearchCache.setHorizontalGroup(
            gl_pnlSearchCache.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlSearchCache.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblSearchCache)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(fldSearchCache, GroupLayout.PREFERRED_SIZE, 55, GroupLayout.PREFERRED_SIZE)
                .addContainerGap(269, Short.MAX_VALUE))
        );
        gl_pnlSearchCache.setVerticalGroup(
            gl_pnlSearchCache.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlSearchCache.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlSearchCache.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(lblSearchCache)
                    .addComponent(fldSearchCache, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        GroupLayout gl_pnlSearch = new GroupLayout(pnlSearch);
        pnlSearch.setLayout(gl_pnlSearch);
        gl_pnlSearch.setHorizontalGroup(
            gl_pnlSearch.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(GroupLayout.Alignment.TRAILING, gl_pnlSearch.createSequentialGroup()
                .addContainerGap()
                .addGroup(gl_pnlSearch.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(pnlSearchCache, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnlSearchComment, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnlSearchVideo, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        gl_pnlSearch.setVerticalGroup(
            gl_pnlSearch.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(gl_pnlSearch.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlSearchVideo, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(pnlSearchComment, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(ComponentPlacement.RELATED)
                .addComponent(pnlSearchCache, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addContainerGap(27, Short.MAX_VALUE))
        );

        tabbedPane.addTab("検索", pnlSearch);

        final JPanel pnlButton = new JPanel();
        final JButton btnOk = new JButton("OK");
        btnOk.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                saveConfig();
                dispose();
            }
        });
        final JButton btnCancel = new JButton("Cancel");
        pnlButton.add(btnOk);
        pnlButton.add(btnCancel);

        GroupLayout layout = new GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addComponent(tabbedPane, GroupLayout.DEFAULT_SIZE, 460, Short.MAX_VALUE)
            .addComponent(pnlButton)
        );
        layout.setVerticalGroup(
            layout.createSequentialGroup()
                .addComponent(tabbedPane,GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE, GroupLayout.PREFERRED_SIZE)
                .addComponent(pnlButton)
        );

        final JLabel lblSystemThreadDownload = new JLabel("ダウンロードスレッド数");
        final JLabel lblSystemWaitDownload = new JLabel("ダウンロード開始最小間隔(秒)");
        final JLabel lblSystemThreadConvert = new JLabel("変換スレッド数");
        final JLabel lblSystemTempDir = new JLabel("作業フォルダ");

        final JPanel pnlSystemGeneral = new JPanel();
        pnlSystemGeneral.setBorder(BorderFactory.createTitledBorder("システム"));
        final GroupLayout glSystemGenegal = new GroupLayout(pnlSystemGeneral);
        glSystemGenegal.setAutoCreateGaps(true);
        glSystemGenegal.setAutoCreateContainerGaps(true);
        pnlSystemGeneral.setLayout(glSystemGenegal);

        glSystemGenegal.setHorizontalGroup(glSystemGenegal.createParallelGroup()
            .addGroup(glSystemGenegal.createSequentialGroup()
                .addGroup(glSystemGenegal.createParallelGroup()
                    .addComponent(lblSystemThreadDownload)
                    .addComponent(lblSystemWaitDownload)
                    .addComponent(lblSystemThreadConvert))
                .addGroup(glSystemGenegal.createParallelGroup()
                    .addComponent(fldSystemThreadDownload, PREFERRED_SIZE, 40, PREFERRED_SIZE)
                    .addComponent(fldSystemWaitDownload, PREFERRED_SIZE, 40, PREFERRED_SIZE)
                    .addComponent(fldSystemThreadConvert, PREFERRED_SIZE, 40, PREFERRED_SIZE)
                )
            )
            .addGroup(glSystemGenegal.createSequentialGroup()
                .addComponent(lblSystemTempDir)
                .addComponent(fldSystemTempDir, DEFAULT_SIZE, 400, Short.MAX_VALUE)
                )
            );

        glSystemGenegal.setVerticalGroup(glSystemGenegal.createSequentialGroup()
            .addGroup(glSystemGenegal.createParallelGroup(Alignment.BASELINE)
                .addComponent(lblSystemThreadDownload)
                .addComponent(fldSystemThreadDownload, DEFAULT_SIZE, PREFERRED_SIZE, PREFERRED_SIZE))
            .addGroup(glSystemGenegal.createParallelGroup(Alignment.BASELINE)
                .addComponent(lblSystemWaitDownload)
                .addComponent(fldSystemWaitDownload, DEFAULT_SIZE, PREFERRED_SIZE, PREFERRED_SIZE))
            .addGroup(glSystemGenegal.createParallelGroup(Alignment.BASELINE)
                .addComponent(lblSystemThreadConvert)
                .addComponent(fldSystemThreadConvert, DEFAULT_SIZE, PREFERRED_SIZE, PREFERRED_SIZE))
            .addGroup(glSystemGenegal.createParallelGroup(Alignment.BASELINE)
                .addComponent(lblSystemTempDir)
                .addComponent(fldSystemTempDir, DEFAULT_SIZE, PREFERRED_SIZE, PREFERRED_SIZE)));

        final JPanel pnlSystem = new JPanel();
        pnlSystem.setBorder(BorderFactory.createEmptyBorder(1, 1, 1, 1));
        final GroupLayout glSystem = new GroupLayout(pnlSystem);
        glSystem.setAutoCreateGaps(true);
        glSystem.setAutoCreateContainerGaps(true);
        pnlSystem.setLayout(glSystem);

        glSystem.setHorizontalGroup(glSystem.createParallelGroup()
            .addComponent(pnlSystemGeneral));

        glSystem.setVerticalGroup(glSystem.createSequentialGroup()
            .addComponent(pnlSystemGeneral));

        tabbedPane.add("システム", pnlSystem);

        pack();
        setResizable(false);
        loadConfig();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (UIManager.LookAndFeelInfo info : UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ConfigDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                new ConfigDialog().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables

    // ネットワーク
    // ネットワーク - アカウント
    private final JTextField fldMail;
    private final JTextField fldPassword;
    // ネットワーク - プロキシ
    private final JCheckBox cbProxyUse;
    private final JTextField fldProxyHost;
    private final JTextField fldProxyPort;
    // ファイル
    // ファイル - 動画
    private final JTextField fldVideoDir;
    private final JButton btnVideoDir;
    private final JTextField fldVideoFileNamePattern;
    private final JCheckBox cbVideoLocal;
    // ファイル - コメント
    private final JTextField fldCommentDir;
    private final JButton btnCommentDir;
    private final JTextField fldCommentFileNamePattern;
    private final JCheckBox cbCommentLocal;
    // ファイル - 変換動画
    private final JTextField fldOutputDir;
    private final JTextField fldOutputFileNamePattern;
    private final JButton btnOutputDir;
    private final JCheckBox cbOutputEnable;
    private final JCheckBox cbOutputCommentOverlay;
    private final JCheckBox cbOutputDisplayProgress;
    // ファイル - 禁則文字
    private final JTextField fldReplaceFrom = new JTextField();
    private final JTextField fldReplaceTo = new JTextField();
    // コメント
    // コメント
    private final JCheckBox cbCommentSizeAuto;
    private final JTextField fldCommentSizeManual;
    private final JCheckBox cbCommentMinSizeAuto;
    private final JTextField fldCommentMinSizeManual;
    private final JCheckBox cbCommentDisplaySizeDefault;
    private final JTextField fldCommentDisplaySizeManual;
    // コメント - 高度な設定
    private final JTextField fldFontPath;
    private final JButton btnFontPath;
    private final JTextField fldFontIndex;
    private final JComboBox<String> cmbFontShadow = new JComboBox<>();
    private final JCheckBox cbFontSizeArrangeDisable;
    private final JCheckBox cbCommentOpaque;
    // ffmpeg
    // ffmpeg - ファイルパス
    private final JTextField fldFfmpegPath;
    private final JButton btnFfmpegPath;
    private final JTextField fldFfmpegDllPath;
    private final JButton btnFfmpegDllPath;
    // ffmpeg - ffmpegパラメータ
    private final FfmpegParamPanel pnlFfmpegParam = new FfmpegParamPanel();
    // NG設定
    // NG設定 - NGワード
    private final NgRegisterPanel pnlNgWord = new NgRegisterPanel();
    // NG設定 - NGID
    private final NgRegisterPanel pnlNgId = new NgRegisterPanel();
    // 検索
    // 検索 - 動画検索対象フォルダ
    private final DirectoryRegisterPanel pnlSearchVideo = new DirectoryRegisterPanel();
    // 検索 - コメント検索対象フォルダ
    private final DirectoryRegisterPanel pnlSearchComment = new DirectoryRegisterPanel();
    // 検索 - キャッシュ更新(秒)
    private final JTextField fldSearchCache;
    // システム
    private final JTextField fldSystemThreadDownload = new JTextField();
    private final JTextField fldSystemWaitDownload = new JTextField();
    private final JTextField fldSystemThreadConvert = new JTextField();
    private final JTextField fldSystemTempDir = new JTextField();


    // End of variables declaration//GEN-END:variables

    private void loadConfig() {
        final Config p = Config.INSTANCE;

        /*
         * ネットワーク - アカウント
         */
        fldMail.setText(p.getId());
        fldPassword.setText(p.getPassword());

        /*
         * ネットワーク - プロキシ
         */
        cbProxyUse.setSelected(p.getProxyUse());
        fldProxyHost.setText(p.getProxyHost());
        fldProxyPort.setText(p.getProxyPort());

        /*
         * ファイル - 動画
         */
        fldVideoDir.setText(p.getVideoDir());
        fldVideoFileNamePattern.setText(p.getVideoFileNamePattern());
        cbVideoLocal.setSelected(p.getVideoUseLocal());

        /*
         * ファイル - コメント
         */
        fldCommentDir.setText(p.getCommentDir());
        fldCommentFileNamePattern.setText(p.getCommentFileNamePattern());
        cbCommentLocal.setSelected(p.getCommentUseLocal());

        /*
         * ファイル - 変換動画
         */
        fldOutputDir.setText(p.getOutputDir());
        fldOutputFileNamePattern.setText(p.getOutputFileNamePattern());
        cbOutputEnable.setSelected(p.getOutputEnable());
        cbOutputCommentOverlay.setSelected(p.getOutputCommentOverlay());
        cbOutputDisplayProgress.setSelected(p.getOutputDisplayProgress());

        /*
         * ファイル - 禁則文字
         */
        fldReplaceFrom.setText(p.getReplaceFrom());
        fldReplaceTo.setText(p.getReplaceTo());

        /**
         * コメント
         */
        cbCommentSizeAuto.setSelected(p.getCommentSizeAutosize());
        fldCommentSizeManual.setText(p.getCommentSizeManual());
        cbCommentMinSizeAuto.setSelected(p.getCommentMinSizeAutosize());
        fldCommentSizeManual.setText(p.getCommentMinSizeManual());
        cbCommentDisplaySizeDefault.setSelected(p.getCommentDisplaySizeDefault());
        fldCommentDisplaySizeManual.setText(p.getCommentDisplaySizeManual());

        /**
         * コメント - 高度な設定
         */
        fldFontPath.setText(p.getFontPath());
        fldFontIndex.setText(p.getFontIndex());
        cmbFontShadow.setSelectedIndex(p.getFontShadow());
        cbFontSizeArrangeDisable.setSelected(p.getFontSizeArrangeDisable());
        cbCommentOpaque.setSelected(p.getCommentOpaque());

        /*
         * ffmpeg - ファイルパス
         */
        fldFfmpegPath.setText(p.getFfmpegPath());
        fldFfmpegDllPath.setText(p.getFfmpegDllPath());

        /*
         * ffmpeg - ffmpegパラメータ
         */
        pnlFfmpegParam.init(p);

        /*
         * NG 設定
         */
        final List<String> ngWords = p.getNgWords();
        pnlNgWord.init(ngWords);
        final List<String> ngIds = p.getNgIds();
        pnlNgId.init(ngIds);

        /*
         * 検索
         */
        pnlSearchVideo.init(p.getSearchVideoDirs());
        pnlSearchComment.init(p.getSearchCommentDirs());

        /*
         * システム
         */
        fldSystemThreadDownload.setText(Integer.toString(p.getSystemDownloadThread()));
        fldSystemWaitDownload.setText(Integer.toString(p.getSystemDownloadWait()));
        fldSystemThreadConvert.setText(Integer.toString(p.getSystemConvertThread()));
        fldSystemTempDir.setText(p.getSystemTempDir());
    }

    private void saveConfig() {
        final Config p = Config.INSTANCE;

        /*
         * ネットワーク - アカウント
         */

        p.setId(fldMail.getText());
        p.setPassword(fldPassword.getText());

        /*
         * ネットワーク - プロキシ
         */
        p.setProxyUse(cbProxyUse.isSelected());
        p.setProxyHost(fldProxyHost.getText());
        p.setProxyPort(fldProxyPort.getText());

        /*
         * ファイル - 動画
         */
        p.setVideoDir(fldVideoDir.getText());
        p.setVideoFileNamePattern(fldVideoFileNamePattern.getText());
        p.setVideoUseLocal(cbVideoLocal.isSelected());

        /*
         * ファイル - コメント
         */
        p.setCommentDir(fldCommentDir.getText());
        p.setCommentFileNamePattern(fldCommentFileNamePattern.getText());
        p.setCommentUseLocal(cbCommentLocal.isSelected());

        /*
         * ファイル - 変換動画
         */
        p.setOutputDir(fldOutputDir.getText());
        p.setOutputFileNamePattern(fldOutputFileNamePattern.getText());
        p.setOutputEnable(cbOutputEnable.isSelected());
        p.setOutputCommentOverlay(cbOutputCommentOverlay.isSelected());
        p.setOutputDisplayProgress(cbOutputDisplayProgress.isSelected());

        /*
         * ファイル - 禁則文字
         */
        p.setReplaceFrom(fldReplaceFrom.getText());
        p.setReplaceTo(fldReplaceTo.getText());

        /*
         * コメント
         */
        p.setCommentSizeAutosize(cbCommentSizeAuto.isSelected());
        p.setCommentSizeManual(fldCommentSizeManual.getText());
        p.setCommentMinSizeAutosize(cbCommentMinSizeAuto.isSelected());
        p.setCommentMinSizeManual(fldCommentSizeManual.getText());
        p.setCommentDisplaySizeDefault(cbCommentDisplaySizeDefault.isSelected());
        p.setCommentDisplaySizeManual(fldCommentDisplaySizeManual.getText());

        /**
         * コメント - 高度な設定
         */
        p.setFontPath(fldFontPath.getText());
        p.setFontIndex(fldFontIndex.getText());
        p.setFontShadow(cmbFontShadow.getSelectedIndex());
        p.setFontSizeArrangeDisable(cbFontSizeArrangeDisable.isSelected());
        p.setCommentOpaque(cbCommentOpaque.isSelected());

        /*
         * ffmpeg - ファイルパス
         */
        p.setFfmpegPath(fldFfmpegPath.getText());
        p.setFfmpegDllPath(fldFfmpegDllPath.getText());

        /*
         * ffmpeg - ffmpegパラメータ
         */
        final File fileFfmpegOption = pnlFfmpegParam.mdlFfmpegOption.getSelectedFile();
        p.setFfmpegOptionFile(fileFfmpegOption != null ? fileFfmpegOption.getPath() : null);
        p.setFfmpegExtension(pnlFfmpegParam.fldFfmpegOptionExtension.getText());
        p.setFfmpegMainOption(pnlFfmpegParam.fldFfmpegOptionMain.getText());
        p.setFfmpegInOption(pnlFfmpegParam.fldFfmpegOptionIn.getText());
        p.setFfmpegOutOption(pnlFfmpegParam.fldFfmpegOptionOut.getText());
        p.setFfmpegAvOption(pnlFfmpegParam.fldFfmpegOptionAv.getText());
        p.setFfmpegResizeEnable(pnlFfmpegParam.cbFfmpegOptionResize.isSelected());
        p.setFfmpegResizeWidth(pnlFfmpegParam.fldFfmpegOptionResizeWidth.getText());
        p.setFfmpegResizeHeight(pnlFfmpegParam.fldFfmpegOptionResizeHeight.getText());
        p.setFfmpegKeepAspect(pnlFfmpegParam.cbFfmpegOptionKeepAspect.isSelected());

        /*
         * NG 設定
         */
        p.setNgWords(pnlNgWord.getAllElements());
        p.setNgIds(pnlNgId.getAllElements());

        /*
         * 検索
         */
        p.setSearchVideoDirs(pnlSearchVideo.getAllElements());
        p.setSearchCommentDirs(pnlSearchComment.getAllElements());

        /*
         * システム
         */
        p.setSystemDownloadThread(Integer.parseInt(fldSystemThreadDownload.getText()));
        p.setSystemDownloadWait(Integer.parseInt(fldSystemWaitDownload.getText()));
        p.setSystemConvertThread(Integer.parseInt(fldSystemThreadConvert.getText()));
        p.setSystemTempDir(fldSystemTempDir.getText());

        try {
            p.save();
        } catch (ConfigurationException ex) {
            logger.log(Level.SEVERE, "コンフィグファイル保存に失敗", ex);
        }
    }
}
